#include <iostream>
#include <algorithm>
using namespace std;



int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    int n, q;
    cin >> n >> q;
    int niz[n];
    int Dk[n];
    int Pk[n];
    for (int i =0; i<n; i++){
        cin >> Dk[i] >> Pk[i];
        if (i==0){
            niz[0]=Dk[0];
        }
        else{
            niz[i]=niz[i-1]+Dk[i];
        }

    }
    for (int i =0; i<n; i++){
        cout<<niz[i]<<" ";

    }

    for (int i = 0; i<q; i++){
        int H;
        cin >> H;
        bool uslov = true;
        for (int j = 0; j<n; j++){
            if (H<niz[j]){
                cout << j+1 << "\n";
                uslov=false;
            }
        }
        if (uslov){
            cout << -1 << "\n";
        }
        
    }

    return 0;
}